Commit | Line | Data |
---|---|---|
dcecc6c7 RD |
1 | #!/bin/sh |
2 | # Disassemble the Code: line in Linux oopses | |
3 | # usage: decodecode < oops.file | |
4 | # | |
5 | # options: set env. variable AFLAGS=options to pass options to "as"; | |
6 | # e.g., to decode an i386 oops on an x86_64 system, use: | |
7 | # AFLAGS=--32 decodecode < 386.oops | |
8 | ||
fa220d89 | 9 | cleanup() { |
5358db0b | 10 | rm -f $T $T.s $T.o $T.oo $T.aa $T.dis |
fa220d89 RD |
11 | exit 1 |
12 | } | |
13 | ||
14 | die() { | |
15 | echo "$@" | |
16 | exit 1 | |
17 | } | |
18 | ||
19 | trap cleanup EXIT | |
20 | ||
21 | T=`mktemp` || die "cannot create temp file" | |
dcecc6c7 RD |
22 | code= |
23 | ||
24 | while read i ; do | |
25 | ||
26 | case "$i" in | |
27 | *Code:*) | |
28 | code=$i | |
29 | ;; | |
30 | esac | |
31 | ||
32 | done | |
33 | ||
34 | if [ -z "$code" ]; then | |
fa220d89 | 35 | rm $T |
dcecc6c7 RD |
36 | exit |
37 | fi | |
38 | ||
39 | echo $code | |
40 | code=`echo $code | sed -e 's/.*Code: //'` | |
41 | ||
5358db0b | 42 | width=`expr index "$code" ' '` |
b396aa03 | 43 | width=$((($width-1)/2)) |
5358db0b RV |
44 | case $width in |
45 | 1) type=byte ;; | |
46 | 2) type=2byte ;; | |
47 | 4) type=4byte ;; | |
48 | esac | |
49 | ||
50 | disas() { | |
b396aa03 | 51 | ${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1 |
5358db0b | 52 | |
b396aa03 RV |
53 | if [ "$ARCH" = "arm" ]; then |
54 | if [ $width -eq 2 ]; then | |
5358db0b RV |
55 | OBJDUMPFLAGS="-M force-thumb" |
56 | fi | |
57 | ||
58 | ${CROSS_COMPILE}strip $1.o | |
59 | fi | |
60 | ||
61 | ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \ | |
b396aa03 | 62 | grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1 |
5358db0b RV |
63 | } |
64 | ||
dcecc6c7 RD |
65 | marker=`expr index "$code" "\<"` |
66 | if [ $marker -eq 0 ]; then | |
67 | marker=`expr index "$code" "\("` | |
68 | fi | |
69 | ||
846442c8 | 70 | touch $T.oo |
dcecc6c7 | 71 | if [ $marker -ne 0 ]; then |
846442c8 AV |
72 | echo All code >> $T.oo |
73 | echo ======== >> $T.oo | |
74 | beforemark=`echo "$code"` | |
5358db0b RV |
75 | echo -n " .$type 0x" > $T.s |
76 | echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s | |
77 | disas $T | |
78 | cat $T.dis >> $T.oo | |
79 | rm -f $T.o $T.s $T.dis | |
dcecc6c7 RD |
80 | |
81 | # and fix code at-and-after marker | |
82 | code=`echo "$code" | cut -c$((${marker} + 1))-` | |
83 | fi | |
846442c8 AV |
84 | echo Code starting with the faulting instruction > $T.aa |
85 | echo =========================================== >> $T.aa | |
5358db0b RV |
86 | code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'` |
87 | echo -n " .$type 0x" > $T.s | |
dcecc6c7 | 88 | echo $code >> $T.s |
5358db0b RV |
89 | disas $T |
90 | cat $T.dis >> $T.aa | |
846442c8 | 91 | |
5358db0b RV |
92 | faultline=`cat $T.dis | head -1 | cut -d":" -f2` |
93 | faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'` | |
846442c8 AV |
94 | |
95 | cat $T.oo | sed -e "s/\($faultline\)/\*\1 <-- trapping instruction/g" | |
96 | echo | |
97 | cat $T.aa | |
98 | cleanup |